package PScm::Token;

use strict;
use warnings;
use base qw(PScm);

sub is_open_token { 0 }
sub is_close_token { 0 }
sub is_quote_token { 0 }
sub is_unquote_token { 0 }
sub is_dot_token { 0 }
sub is_expr { 0 }

##########################
package PScm::Token::Open;

use base qw(PScm::Token);

sub is_open_token { 1 }

###########################
package PScm::Token::Close;

use base qw(PScm::Token);

sub is_close_token { 1 }

###########################
package PScm::Token::Quote;

use base qw(PScm::Token);

sub is_quote_token { 1 }

#############################
package PScm::Token::Unquote;

use base qw(PScm::Token::Quote);

sub is_unquote_token { 1 }

#########################
package PScm::Token::Dot;

use base qw(PScm::Token);

sub is_dot_token { 1 }

1;
